package org.aleabodo.fireworksmc;

import com.github.fierioziy.particlenativeapi.api.ParticleNativeAPI;
import com.github.fierioziy.particlenativeapi.plugin.ParticleNativePlugin;
import org.aleabodo.fireworksmc.Commands.Fireworkshow;
import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.World;
import org.bukkit.plugin.RegisteredServiceProvider;
import org.bukkit.plugin.java.JavaPlugin;

import java.io.Console;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.Objects;
import java.util.Random;
import java.util.UUID;
import java.util.logging.Level;

public final class Fireworks_Mc extends JavaPlugin {
    private static ParticleNativeAPI particlesAPI;
    private static Fireworks_Mc plugin;

    public static Show show;
    public static Config config;

    @Override
    public void onEnable() {
        Fireworks_Mc.plugin = this;

        getLogger().info("Starting Fireworks-MC plugin ...");

        /*
         * Initialize Particles API
         * Requires the ParticlesNativeAPI plugin
         */
        if (!ParticleNativePlugin.isValid()) {
            getLogger().log(Level.SEVERE, "Error occurred while loading Particles API dependency.");
            this.setEnabled(false);
            return;
        }
        particlesAPI = ParticleNativePlugin.getAPI();

        /*
         * Initilize config
         */
        Fireworks_Mc.config = new Config();

        //Initialize show with default values
        /*Fireworks_Mc.show = new Show("Survival-Pi",
                new Location(Fireworks_Mc.getWorld("world"), 0, 80, 0),
                Direction.NORTH,
                60,76);
*/
        /*
         * Initialize command executors
         */
        Objects.requireNonNull(getCommand("fireworkshow")).setExecutor(new Fireworkshow());
        Objects.requireNonNull(getCommand("fs")).setExecutor(new Fireworkshow()); //Command alias for fireworkshow
    }

    @Override
    public void onDisable() {

    }

    /*
     * ################### GETTER ###################
     */

    public static World getWorld(UUID worldUUID) {
        return Fireworks_Mc.plugin.getServer().getWorld(worldUUID);
    }

    public static World getWorld(String worldName) {
        return Fireworks_Mc.plugin.getServer().getWorld(worldName);
    }

    public static Fireworks_Mc getPlugin() {
        return plugin;
    }

    /*
     * ################### SETTER ###################
     */


}
